HDU 3535:AreYouBusy

来源:互联网 发布:warframe淘宝白金 编辑:程序博客网 时间:2024/05/18 00:14

AreYouBusy

查看原题
Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4576    Accepted Submission(s): 1865


Problem Description
Happy New Term!
As having become a junior, xiaoA recognizes that there is not much time for her to AC problems, because there are some other things for her to do, which makes her nearly mad.
What's more, her boss tells her that for some sets of duties, she must choose at least one job to do, but for some sets of things, she can only choose at most one to do, which is meaningless to the boss. And for others, she can do of her will. We just define the things that she can choose as "jobs". A job takes time , and gives xiaoA some points of happiness (which means that she is always willing to do the jobs).So can you choose the best sets of them to give her the maximum points of happiness and also to be a good junior(which means that she should follow the boss's advice)?
 

Input
There are several test cases, each test case begins with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose and T minutes for her to do them. Follows are n sets of description, each of which starts with two integers m and s (0<m<=100), there are m jobs in this set , and the set type is s, (0 stands for the sets that should choose at least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the one you can choose freely).then m pairs of integers ci,gi follows (0<=ci,gi<=100), means the ith job cost ci minutes to finish and gi points of happiness can be gained by finishing it. One job can be done only once.
 

Output
One line for each test case contains the maximum points of happiness we can choose from all jobs .if she can’t finish what her boss want, just output -1 .
 

Sample Input
3 32 12 53 82 01 02 13 24 32 11 13 42 12 53 82 01 12 83 24 42 11 11 11 02 15 32 01 02 12 02 21 12 03 22 12 11 52 83 23 84 95 10
 

Sample Output
513-1-1
 

Author
hphp
 

Source
2010 ACM-ICPC Multi-University Training Contest(10)——Host by HEU


题意:

有n个组的工作,有t的时间去做对于组有三种类型

2随意,拿或者不拿,选其中多少都可以

1最多选一个

0至少选一个

每组每件事有花费的时间和收益取尽量高的收益


解题思路:

第一类(01背包坑点多),至少选一项,即必须要选,那么在开始时,对于这一组的dp的初值,应该全部赋为负无穷,这样才能保证不会出现都不选的情况。

状态转移方程:dp[i][j]=max(dp[i][j],max(dp[i][j-w[x]]+p[x],dp[i-1][j-w[x]]+p[x]));

dp[i][j]: 是不选择当前工作;

dp[i-1][j-w[x]]+p[x]: 第一次在本组中选物品,由于开始将该组dp赋为了负无穷,所以第一次取时,必须由上一组的结果推知,这样才能保证得到全局最优解;

dp[i][j-w[x]]+p[x]:表示选择当前工作,并且不是第一次取;

  第二类(分组背包),最多选一项,即要么不选,一旦选,只能是第一次选。

状态转移方程:dp[i][j]=max(dp[i][j],dp[i-1][j-w[x]]+p[x]);

由于要保证得到全局最优解,所以在该组DP开始以前,应该将上一组的DP结果先复制到这一组的dp[i]数组里,因为当前组的数据是在上一组数据的基础上进行更新的。

     第三类01背包),任意选,即不论选不选,选几个都可以。

状态转移方程为:dp[i][j]=max(dp[i][j],dp[i][j-w[x]]+p[x]);

同样要保证为得到全局最优解,先复制上一组解,数据在当前组更新。


源代码:


#include<iostream>#include<cstdio>#include<cstring>const int N=110;const int INF=0x3f3f3f3f;int max(int a,int b){return a>b?a:b;}int n,m,t;int dp[N][N],w[N],v[N];int main(){    while(scanf("%d%d",&n,&t)!=EOF)    {        memset(dp,0,sizeof(dp));        int g;        for(int i=1;i<=n;i++)        {            scanf("%d%d",&m,&g);            for(int j=0;j<m;j++)                scanf("%d%d",&w[j],&v[j]);            if(g==0)//至少选一项,01背包变形            {                for(int j=0;j<=t;j++)                    dp[i][j]=-INF;                for(int k=0;k<m;k++)                    for(int j=t;j>=w[k];j--)                        dp[i][j]=max(dp[i][j],max(dp[i][j-w[k]]+v[k],dp[i-1][j-w[k]]+v[k]));            }            if(g==1)//最多选一项,分组背包            {                for(int j=0;j<=t;j++)                    dp[i][j]=dp[i-1][j];                 for(int k=0;k<m;k++)                    for(int j=t;j>=w[k];j--)                        dp[i][j]=max(dp[i][j],dp[i-1][j-w[k]]+v[k]);            }            if(g==2)//任意选,01背包问题            {                 for(int j=0;j<=t;j++)                    dp[i][j]=dp[i-1][j];                 for(int k=0;k<m;k++)                    for(int j=t;j>=w[k];j--)                        dp[i][j]=max(dp[i][j],dp[i][j-w[k]]+v[k]);            }        }            dp[n][t]=max(dp[n][t],-1);            printf("%d\n",dp[n][t]);    }    return 0;}


原创粉丝点击